import os
import requests
from lxml import etree


class QiuShiBaiKe:
    def __init__(self):
        # 糗事百科上对应类型的网址
        self.urls = {
            "index": "https://www.qiushibaike.com",
            "text": "https://www.qiushibaike.com/text/page/{}",
            "video": "https://www.qiushibaike.com/video/page/{}",
            "img": 'https://www.qiushibaike.com/imgrank/page/{}'
        }
        # 该类型首页对应的xpath
        self.xpaths = {
            "text": '//*[@class="col1 old-style-col1"]/div/a[2]/@href',
            "video": '//video/source/@src',
            "img": '//div[@class="thumb"]/a/img/@src'
        }
        # 构造请求头
        self.headers = {
            'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4606.61 Safari/537.36',
        }
        self.path = os.getcwd()
        self.make_folder()

    def make_folder(self, folder="qiushi"):
        # 在代码文件夹内创建文件夹，并将定位至该文件夹路径
        if folder not in os.listdir(self.path):
            os.mkdir(folder)
        os.chdir(os.path.join(self.path, folder))

    def get_url(self, kind, page):
        # 请求类型首页，解析相关文件路由
        url = self.urls[kind].format(page)
        html = requests.get(url, headers=self.headers)
        demo = etree.HTML(html.text)
        self.url_list = demo.xpath(self.xpaths[kind])

    def download_text(self, page=1):
        # 进入段子详细页，并下载段子
        self.get_url('text', page)
        print(self.url_list)
        url0 = "https://www.qiushibaike.com"
        xpath = '//*[@id="single-next-link"]/div/text()'
        for text_url in self.url_list:
            url = url0 + text_url
            print('正在保存段子!\t%s' % url)
            html = requests.get(url, headers=self.headers)
            demo = etree.HTML(html.text)
            text = demo.xpath(xpath)
            with open("段子.txt", "a", encoding='utf-8') as file:
                for t in text:
                    file.write(t)
                file.write("-" * 150 + "\n\n\n")

    def download_file(self, kind='video', page=1):
        # 直接请求文件网址，下载保存文件，可下载类型为视频及图片
        self.get_url(kind, page)
        for file_url in self.url_list:
            url = "http:" + file_url
            file_name = (file_url.split("/"))[-1]
            print("正在下载文件！\t%s" % url)
            try:
                response = requests.get(url, self.headers)
                with open(file_name, "wb") as file:
                    file.write(response.content)
            except:
                print("文件下载失败！")

if __name__ == "__main__":
    qiushi = QiuShiBaiKe()                      # 初始化
    qiushi.download_text()                      # 下载段子
    qiushi.download_file()                      # 下载视频
    qiushi.download_file(kind="img")            # 下载图片

